/****************************************************************************
 Copyright (c) 2010-2012 cocos2d-x.org
 Copyright (c) 2008-2010 Ricardo Quesada
 Copyright (c) 2011      Zynga Inc.

 http://www.cocos2d-x.org

 Permission is hereby granted, free of charge, to any person obtaining a copy
 of this software and associated documentation files (the "Software"), to deal
 in the Software without restriction, including without limitation the rights
 to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 copies of the Software, and to permit persons to whom the Software is
 furnished to do so, subject to the following conditions:

 The above copyright notice and this permission notice shall be included in
 all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 THE SOFTWARE.
 ****************************************************************************/



var IntroLayer = cc.Layer.extend({
    label1:null,
    ctor:function () {
        this._super();
        var size =  cc.winSize;
        this.label1 = cc.LabelTTF.create("Play the gam", "Impact", 100);
        this.label1.setPosition(size.width / 2, size.height/2);

        this.addChild(this.label1);
        return true;
    }
});

// Define MyScene as a subclass of cc.Scene
var MyScene = cc.Scene.extend({
    // on entering the scene, following code will be executed
    onEnter:function () {
        this._super();
        // create and add a layer to the scene
        var layer = new LevelLayer();
        var introLay = new IntroLayer();
        var pla = new PlayerLayer();
        
       
        
        this.addChild(layer, 0, 0);
        this.addChild(pla, 1, 10);
     //   this.addChild(introLay, 2, 2);
    }
});

var MenuLayer = cc.Layer.extend({
    
    init:function () {
        
        var platSprite = cc.Sprite.create(asset.intro_image);
            platSprite.setAnchorPoint(0.5, 0.5);
            platSprite.setScale(1);
            platSprite.setPosition(cc.winSize.width/2,                    
                                   cc.winSize.height/2);
            this.addChild(platSprite, 0, 2);
        
        
        var menuItemPlay = new cc.MenuItemSprite(
            new cc.Sprite(asset.clk_down), // normal state image
            new cc.Sprite(asset.clk_up), //select state image
            this.onPlay, this);
        var menu = new cc.Menu(menuItemPlay); //7. create the menu
        menu.setPosition(cc.winSize.width/2, cc.winSize.height/2 - 60);
        this.addChild(menu);
        
        
        
    },

    onPlay: function() {
        cc.director.runScene(new MyScene());
       
    }
});

var MenuScene = cc.Scene.extend({
    
    onEnter: function() {
        this._super();
        var layer = new MenuLayer();
        layer.init();
        this.addChild(layer);
        
        cc.audioEngine.playMusic(asset.background_wav, true);
    }
    
    
});