var PlayerLayer = cc.Layer.extend({

    worldPosX:null,
    worldPosY:null,
    playerSprite:null,
    velX:null,
    velY:null,
    h:null,
    time:null,
    runningAction:null,
    spriteSheetRun:null,
    falling:null,
    jumping:null,
    standing:null,
    isJumping:null,
    ctor:function () {
        this._super();
        this.worldPosX = 0;
        this.worldPosY = 400;
        this.velX = 5;
        this.velY = 0;
        this.h = 0.01;
        this.time = 0;
        this.isJumping = false;
        
        
        
        cc.spriteFrameCache.addSpriteFrames(asset.running_anim_png);
        
        this.spriteSheetRun = new cc.SpriteBatchNode(asset.running_anim_png);
        this.addChild(this.spriteSheetRun);


        // init runningAction
        var animFrames = [];
        var frame
        for (var i = 1; i < 7; i++) {
            var str = "run" + i + ".png";
            frame = cc.spriteFrameCache.getSpriteFrame(str);
            animFrames.push(frame);
        }

        var animation = new cc.Animation(animFrames, 0.1);
        this.runningAction = new cc.RepeatForever(new cc.Animate(animation));
        this.runningAction.setTag(1);
        this.playerSprite = new cc.Sprite("#run1.png");

        self=this;
        cc.eventManager.addListener(cc.EventListener.create({
            event: cc.EventListener.TOUCH_ONE_BY_ONE,
            onTouchBegan: function(touch,event) {
                self.jump();
            }}), this.playerSprite);
        
        
        
        this.playerSprite.runAction(this.runningAction);
        this.spriteSheetRun.addChild(this.playerSprite);
        this.playerSprite.setPosition(400, 150);
        this.addChild(this.playerSprite);
        
        animFrames = [];
        frame = new cc.SpriteFrame("asset/falling.png", cc.rect(0,0,153,190));
        animFrames.push(frame);
        animation = new cc.Animation(animFrames, 0.2);
        this.falling = new cc.Animate(animation);
        this.falling.retain();
        
        animFrames = [];
        frame = new cc.SpriteFrame("asset/jump.png", cc.rect(0,0,153,190));
        animFrames.push(frame);
        animation = new cc.Animation(animFrames, 0.2);
        this.jumping = new cc.Animate(animation);
        this.jumping.retain();
        
        
        animFrames = [];
        frame = new cc.SpriteFrame("asset/stand.png", cc.rect(0,0,153,190));
        animFrames.push(frame);
        animation = new cc.Animation(animFrames, 0.2);
        this.standing = new cc.Animate(animation);
        this.standing.retain();
        
        this.scheduleUpdate();
        
        
        return true;
    },
    getEyeX:function() {
        return this.worldPosX;
        
    },
    getEyeY:function() {
        return this.worldPosY;
    },
    update:function(dt) {
        this.time += dt
        this.checkCollision();
        if(this.velY == 0) {
            isJumping = false;
          //  this.playerSprite.runAction(this.runningAction);
        }
        else if(this.velY < -.3) {
            this.playerSprite.runAction(this.falling);
        }
        else if(this.velY > .3) {
            this.playerSprite.runAction(this.jumping);
        }
        
        if(this.velX == 0) {
            this.playerSprite.runAction(this.standing);
        }
        
        this.worldPosX = this.worldPosX +  this.velX;
        this.worldPosY = this.worldPosY +  this.velY ;
      //  this.velX += .1;
        this.velY = this.velY - .3;    
        this.velX = 5;
    },
    
    checkCollision:function()  {
        //Gets a list of all collision actors
        var mapChildren = this.getParent().getChildByTag(0).getChildren();

        for(var i = 0; i < mapChildren.length ; i++) {
            var other = mapChildren[i];
            var collX = false;
            var collY = false;
            if(this.CollidesWith() && other.getTag() == 15) {
                var x1 = this.playerSprite.x;
                var y1 = this.playerSprite.y;
                var w1 = this.playerSprite.getBoundingBox().width;
                var h1 = this.playerSprite.getBoundingBox().height;
                
                var x2 = other.x - this.worldPosX;
                var y2 = other.y - this.worldPosY;
                var w2 = other.getBoundingBox().width ;
                var h2 = other.getBoundingBox().height;
                if(Math.abs(x1 - x2) * 2 < (w1 + w2))
                {
                    collX = true;
                }
            
                if(Math.abs(y1 - y2) * 2 < (h1 + h2))
                {
                    collY = true;
                }
                
                if(collX == true && collY == true) {
                    var thisLeft = x1 - (w1 / 2);
                    var thisRight = x1 + (w1 / 2);
                    var thisTop = y1 - (h1 / 2);
                    var thisBottom = y1 + (h1 / 2);
                    
                    var otherLeft = x2 - (w2 / 2);
                    var otherRight = x2 + (w2 / 2);
                    var otherTop = y2 - (h2 / 2);
                    var otherBottom = y2 + (h2 / 2);
                    
                    var rightmostLeftEdge = thisLeft > otherLeft ? thisLeft : otherLeft;
                    var leftmostRightEdge = thisRight < otherRight ? thisRight : otherRight;
                    var bottommostTopEdge = thisTop > otherTop ? thisTop : otherTop;
                    var topmostBottomEdge = thisBottom < otherBottom ? thisBottom : otherBottom;
                    
                    var collisionWidth = leftmostRightEdge - rightmostLeftEdge;
                    var collisionHeight = topmostBottomEdge - bottommostTopEdge;
                    
                    if( collisionWidth < collisionHeight) {
                        collY = false; 
                    } else {
                        collX = false;
                    }
                    
                    if(collY) {
                        if(this.y1 <= this.y2)
                        {
                            this.velY = -this.velY;
                        }
                        else
                        {
                            if( this.velY < 0) {
                                this.velY = 0;
                                this.worldPosY -= ( y1 - h1/2) - (h2/2 + y2) + .3;
                            }
                        }
                    }
                    else if(collX ) {
                        this.velX = 0;
                    }
                    
                }
                
            }
        }
    },
    CollidesWith:function() {
        return true;
    },
    jump: function() {
        if(isJumping == false) {
            this.velY = 10;
            isJumping = true;
        }
    }
});